<?php

namespace App\Models;

use App\Foundation\Scopes\CategoryScope;
use Mcamara\LaravelLocalization\Interfaces\LocalizedUrlRoutable;


class Category extends Taxonomy
{
    //
    protected static function boot(){
        parent::boot();
        static::addGlobalScope(new CategoryScope());
    }

    public function getForeignKey()
    {
        return parent::getForeignKey(); // TODO: Change the autogenerated stub
    }



    /**
     * category nested children
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function children()
    {
        return $this->hasMany(Category::class, 'parent')->orderBy('sorting');
    }
    /**
     * Checks if the category has a children
     * @return bool
     */
    public function hasChildren()
    {
        return $this->children()->exists();
    }
    /**
     * Get the child category's parent, returns null if root category
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function parentCategory()
    {
        return $this->belongsTo(Category::class, 'parent');
    }
    /**
     * Get all of the gallery's images.
     */
    public function image()
    {
        return $this->morphOne(Image::class, 'imageable');
    }
    public function gallery()
    {
        return $this->belongsTo(Gallery::class, 'gallery_id');
    }
    public function pages(){
        return   $this->belongsToMany(Page::class,'node_taxonomies','taxonomy_id');
    }
    public function posts(){
        return   $this->belongsToMany(Post::class,'node_taxonomies','taxonomy_id');
    }

    public function events(){
        return   $this->belongsToMany(Event::class,'node_taxonomies','taxonomy_id');
    }

    public function advertisements(){
        return $this->hasMany(Advertisement::class,'category_id');
    }
}
